!define              PRODUCT_NAME "MediaCoder"
!define              VER_MAJOR   "0.5"
!define              VER_MINOR   "0"
!define              PRODUCT_VERSION "${VER_MAJOR}.${VER_MINOR}"
!define              PRODUCT_PUBLISHER "Stanley Huang"
!define              PRODUCT_DIR_REGKEY "Software\Microsoft\Windows\CurrentVersion\App Paths\mediacoder.exe"
;!define              PRODUCT_UNINST_KEY "Software\Microsoft\Windows\CurrentVersion\Uninstall\${PRODUCT_NAME}"
;!define              PRODUCT_UNINST_ROOT_KEY "HKLM"

!define              FILE_PATH "../release" ;װļĿ¼
!define              MAIN_APP "$INSTDIR\mediacoder.exe"

Name                 "${PRODUCT_NAME} ${VER_MAJOR}.${VER_MINOR} Extra Codecs Pack"
OutFile              "mediacoder-codecs.exe"

SetCompressor        /FINAL /SOLID lzma
SpaceTexts           none
;ShowInstDetails      show
;ShowUninstDetails    show
BrandingText         "${PRODUCT_NAME} $(INSTALLER) ${__DATE__}"
Caption              "$(^Name)"
InstallDir           "$PROGRAMFILES\${PRODUCT_NAME}"
InstallDirRegKey     HKLM "${PRODUCT_DIR_REGKEY}" ""

ReserveFile          "${NSISDIR}\Plugins\System.dll"
ReserveFile          "${NSISDIR}\Plugins\LangDLL.dll"

!include             MUI.nsh
!include             Language.nsh
!addincludedir       "..\[MyFunctions]"
!include             BlueHelper.nsh

; MUI Settings(GLOBAL)
!define MUI_ABORTWARNING
!define MUI_ICON ".\resource\ico-inst.ico"
!define MUI_HEADERIMAGE
!define MUI_HEADERIMAGE_BITMAP ".\resource\header-foobar.bmp"

;----------------------------------- insert page
!define MUI_PAGE_CUSTOMFUNCTION_SHOW ChkBeforeInstall
; Welcome page
;!define MUI_WELCOMEFINISHPAGE_BITMAP ".\resource\wiz-foobar.bmp"
;!define MUI_WELCOMEPAGE_TEXT "$(WELCOMEPAGE_TEXT)"
;!insertmacro MUI_PAGE_WELCOME
; Setup directory page
!insertmacro MUI_PAGE_DIRECTORY
; Components page
;!insertmacro MUI_PAGE_COMPONENTS
; Instfiles page
!insertmacro MUI_PAGE_INSTFILES
; Finish page
!define MUI_PAGE_CUSTOMFUNCTION_SHOW ChangeFont	
;!define MUI_FINISHPAGE_RUN "${MAIN_APP}"
;!define MUI_FINISHPAGE_SHOWREADME "$INSTDIR\whatsnew.txt"
;!define MUI_FINISHPAGE_SHOWREADME_NOTCHECKED
!insertmacro MUI_PAGE_FINISH
	
!insertmacro MUI_UNPAGE_CONFIRM
!insertmacro MUI_UNPAGE_INSTFILES
;language page	
!insertmacro MUI_LANGUAGE "English"
;!insertmacro MUI_LANGUAGE "SimpChinese"
;ChangeUI IDD_SELCOM ".\resource\myui.exe"

!define File `!insertmacro File`

!macro File FILE
       File "${FILE_PATH}\${FILE}"
!macroend	

Function ChangeFont
        GetDlgItem $0 $MUI_HWND 1201
        CreateFont $1 "Tahoma" "11" "700"
        SendMessage $0 ${WM_SETFONT} $1 0
FunctionEnd	

Function ChkBeforeInstall
;  ${IsWinNT} $0
;  ${If} $0 = ${FALSE}
;  	MessageBox MB_OK|MB_ICONEXCLAMATION "$(WIN9X_WARNING)"
;  	Quit
;  ${EndIf}
FunctionEnd

Section "$(Main)" main_components
  SectionIn 1 RO
	
	;һĸתΪд
	${UpperDrvChar} $INSTDIR
	
        SetOutPath "$INSTDIR\codecs"
        ${File} "codecs\libamr.dll"
        ${File} "codecs\enc_aacplus.dll"
        ${File} "codecs\nscrt.dll"
	SetOutPath "$INSTDIR\codecs\producer"
	${File} "codecs\producer\producer.exe"
	${File} "codecs\producer\producer.pref"
	${File} "codecs\producer\pncrt.dll"
	${File} "codecs\producer\default.rpjf"
	SetOutPath "$INSTDIR\codecs\producer\audiences"
	${File} "codecs\producer\audiences\*.rpad"
	SetOutPath "$INSTDIR\codecs\producer\codecs"
	${File} "codecs\producer\codecs\*.dll"
	SetOutPath "$INSTDIR\codecs\producer\common"
	${File} "codecs\producer\common\*.dll"
	SetOutPath "$INSTDIR\codecs\producer\plugins"
	${File} "codecs\producer\plugins\*.dll"
	SetOutPath "$INSTDIR\codecs\producer\tools"
	${File} "codecs\producer\tools\*.dll"
	SetOutPath "$INSTDIR\codecs\producer\resources"
	${File} "codecs\producer\resources\CodecMapping.txt"
	SetOutPath "$INSTDIR\mplayer"
        ${File} "..\codecs\mpcodecs\*.*"
SectionEnd

; --------------------------------------

Function .onInit
	InitPluginsDir
	System::Call 'kernel32::CreateMutexA(i 0, i 0, t "$(^Name)") i .r1 ?e'
	Pop $0
	StrCmp $0 0 +3
		MessageBox MB_OK|MB_ICONEXCLAMATION "$(Mutex)"
		Quit
		
	!insertmacro MUI_LANGDLL_DISPLAY
FunctionEnd

