var url = document.location.href;
var xmlhttp;
if(window.XMLHttpRequest)
	xmlhttp = new XMLHttpRequest;
else
	xmlhttp = new ActiveXObject("Msxml2.XMLHTTP");
if (!xmlhttp) alert("XMLHttpRequest object cannot be created.");

function getNextNode(node)
{
	do {
		node = node.nextSibling;
	} while (node !=null && node.nodeType != 1);
	return node;
}

function getChildNode(node)
{
	node = node.firstChild;
	while (node !=null && node.nodeType != 1) {
		node = node.nextSibling;
	} 
	return node;
}

function getAttribute(node, name)
{
	var i;
	for (i = 0; node.attributes[i] != null; i++) {
		if (node.attributes[i].name == name) return node.attributes[i].value;
	}
	return null;
}

function getNodeValue(node)
{
	return node.firstChild ? node.firstChild.nodeValue : null
}

function getParentNode(node)
{
	return node.parentNode;
}

function findNode(node, name)
{
	for (; node && node.nodeName != name; node = getNextNode(node));
	return node;
}

function GetToken(str, token)
{
	var idx = str.indexOf(token + '=');
	if (idx <= 0) return null;
	var argstr = str.substring(idx + token.length + 1);
	idx = argstr.indexOf('&');
	return idx >=0 ? argstr.substring(0, idx) : argstr;
}

function QueryPref(path, opts)
{
	var node;
	var requrl = "/pref/pref.xml?type&";
	if (opts)
		requrl += opts + "&";
	if (path)
		requrl += "path=" + path;
	xmlhttp.open("GET", requrl, false);
	xmlhttp.send(null);
	node = xmlhttp.responseXML.firstChild;
	if (!node || node.nodeName != "MediaCoderPref") {
		alert("Failed to connect to MediaCoder.");
		return null;
	}
	return node;
}

function QueryPlugin(type, option)
{
	var node;
	var requrl = "/pref/plugin.xml?type=" + type;
	if (option) requrl += "&" + option;
	xmlhttp.open("GET", requrl, false);
	xmlhttp.send(null);
	node = xmlhttp.responseXML.firstChild;
	if (!node || node.nodeName != "MediaCoderPlugins") {
		alert("Failed to connect to MediaCoder.");
		return null;
	}
	node = getChildNode(node);
	if (type) node = findNode(node, type);
	return node;
}

function QueryForText(url, async)
{
	xmlhttp.open("GET", url, async);
	xmlhttp.send(null);
	return xmlhttp.responseText;
}

function SetPrefValue(param, val)
{
	xmlhttp.open("GET", "/pref/set?" + param + "=" + val, true);
	xmlhttp.send(null);
}

function GetPrefValue(param)
{
	xmlhttp.open("GET", "/pref/get?path=" + param, false);
	xmlhttp.send(null);
	return xmlhttp.responseText
}

function RevertPrefValue(param)
{
	xmlhttp.open("GET", "/pref/revert?path=" + param, false);
	xmlhttp.send(null);
	return xmlhttp.responseText
}
