/*******************************************************************
* AMR audio encoding library for MediaCoder
* Copyright (c) 2005-06 Stanley Huang <reachme@citiz.net>
* All rights reserved.
*******************************************************************/

typedef short AMR_WORD16;
typedef unsigned char AMR_UWORD8;
#define NB_SERIAL_MAX 61   /* max serial size      */
#define AMRNB_FRAME_SIZE 160	/* number of samples of a frame */
#define AMRWB_FRAME_SIZE 320	/* number of samples of a frame */
#define AMRWB_MAGIC_NUMBER "#!AMR-WB\n"
#define AMRNB_MAGIC_NUMBER "#!AMR\n"

// AMR Narrow-Band 
/*
 * definition of modes for encoder
 */
enum Mode { MR475 = 0,
            MR515,
            MR59,
            MR67,
            MR74,
            MR795,
            MR102,
            MR122,
            MRDTX
};

void * Encoder_Interface_init( int dtx );
typedef void* (*pfn_amrnb_init)( int dtx );

void Encoder_Interface_exit( void *state );
typedef void (*pfn_amr_exit)( void *state );

// only accept 8Khz mono input
#ifndef ETSI
int Encoder_Interface_Encode( void *st, enum Mode mode, AMR_WORD16 *speech, AMR_UWORD8 *serial, int force_speech );
typedef int (*pfn_amrnb_encode)( void *st, enum Mode mode, AMR_WORD16 *speech, AMR_UWORD8 *serial, int force_speech );
#else
int Encoder_Interface_Encode( void *st, enum Mode mode, AMR_WORD16 *speech, AMR_WORD16 *serial, int force_speech );
typedef int (*pfn_amrnb_encode)( void *st, enum Mode mode, AMR_WORD16 *speech, AMR_WORD16 *serial, int force_speech );
#endif

// AMR Narrow-Band decoding
void Decoder_Interface_exit( void *state );
void * Decoder_Interface_init( );
void Decoder_Interface_Decode( void *st, AMR_UWORD8 *bits, AMR_WORD16 *synth, int bfi);

typedef void (*pfn_amrnb_decode)(void *st, AMR_UWORD8 *bits, AMR_WORD16 *synth, int bfi);
typedef void* (*pfn_amrnb_dec_init)();
typedef void (*pfn_amrnb_dec_exit)(void *state);

// AMR Wide-Band
typedef void* (*pfn_amrwb_init)();
void *E_IF_init();

void E_IF_exit(void *state);

// only accept 16Khz mono input
typedef int (*pfn_amrwb_encode)(void *st, AMR_WORD16 req_mode, AMR_WORD16 *speech, AMR_UWORD8 *serial, AMR_WORD16 dtx);
int E_IF_encode(void *st, AMR_WORD16 req_mode, AMR_WORD16 *speech, AMR_UWORD8 *serial, AMR_WORD16 dtx);
