#define MAX_TRACKS 16

class CContainer : public CEncoder
{
public:
	virtual char* UpdateSettings(T_ITEM* item, char* destfile, CONTAINER_TRACKS tracks[]) { return 0; }
	virtual int Mux() { return 0; }
	virtual bool CheckAudioSupport(int id) { return true; }
	virtual bool CheckVideoSupport(int id) { return true; }
	virtual bool IsExternalMuxer() { return false; }
	virtual int ExtractTrack(char* srcfile, CString& destfile, int trackno) { return 0; }
private:
};

class CDefContainer : public CContainer
{
public:
	bool CheckAudioSupport(int id);
	char* GetOutExt(T_ITEM* item);
	char* GetName() { return "Default"; }
};

class CRawContainer : public CContainer
{
public:
	char* GetOutExt(T_ITEM* item);
	char* GetName() { return "Raw Stream"; }
};

class CMatroska : public CContainer
{
public:
	CMatroska() { prefNodePath = "container.matroska"; }
	int Mux();
	char* UpdateSettings(T_ITEM* item, char* destfile, CONTAINER_TRACKS tracks[]);
	char* GetOutExt(T_ITEM* item);
	char* GetName() { return "Matroska"; }
	char* GetVersionInfo();
	bool IsExternalMuxer() { return true; }
	int GetProgress();
private:
	CString cmd;
	SHELL_PARAM sp;
};

class CMp4box : public CContainer
{
public:
	CMp4box() { prefNodePath = "container.mp4box"; }
	int Mux();
	char* UpdateSettings(T_ITEM* item, char* destfile, CONTAINER_TRACKS tracks[]);
	char* GetOutExt(T_ITEM* item);
	char* GetName() { return "MP4"; }
	char* GetVersionInfo();
	int ExtractTrack(char* srcfile, CString& destfile, int trackno);
	bool IsExternalMuxer() { return true; }
	int GetProgress();
private:
	CString cmd;
	SHELL_PARAM sp;
};

class CPMPMuxer: public CContainer
{
public:
	CPMPMuxer() { prefNodePath = "container.pmp"; }
	int Mux();
	char* UpdateSettings(T_ITEM* item, char* destfile, CONTAINER_TRACKS tracks[]);
	char* GetOutExt(T_ITEM* item) { return "pmp"; };
	char* GetName() { return "PMP"; }
	char* GetVersionInfo();
	bool IsExternalMuxer() { return true; }
	bool CheckAudioSupport(int id);
	bool CheckVideoSupport(int id);
	int GetProgress();
private:
	CString cmd;
	SHELL_PARAM sp;
};

class CAVIFormat : public CContainer
{
public:
	CAVIFormat() { prefNodePath = "container.avi"; }
	char* GetOutExt(T_ITEM* item) { return "avi"; }
	char* GetName() { return "AVI"; }
	bool CheckAudioSupport(int id);
};

class CMpegFormat : public CContainer
{
public:
	CMpegFormat() { prefNodePath = "container.mpeg"; }
	char* GetOutExt(T_ITEM* item) { return "mpg"; }
	char* GetName() { return "MPEG"; }
	bool CheckAudioSupport(int id);
	bool CheckVideoSupport(int id);
};

class CLavf : public CContainer
{
public:
	CLavf() { prefNodePath = "container.lavf";}
	char* GetOutExt(T_ITEM* item);
	char* GetName() { return "LAVF"; }
};

class CContainerRaw : public CContainer
{
public:
	char* GetOutExt(T_ITEM* item);
	char* GetName() { return "LAVF"; }
};