#include "paramlistdef.h"

#define HELIX_AUDIENCES "\
 32 Kbps Stereo - RA 10 with aacPlus\0\
 48 Kbps Stereo - RA 10 with aacPlus\0\
 64 Kbps Stereo - RA 10 with aacPlus\0\
 96 Kbps Stereo - RA 10 with aacPlus\0\
 128Kbps Stereo - RA 10 with aacPlus\0\
 12k Substream for 28k Dial-up (11/8.5 kbps)\0\
 16k Substream for 28k Dial-up (16/16 kbps)\0\
 28k Dial-up (20/16 kbps)\0\
 56k Dial-up (CBR, 34 kbps)\0\
 64k Single ISDN (44/32 kbps)\0\
 128k Dual ISDN (96/64 kbps)\0\
 150k LAN (128/64 kbps)\0\
 256k DSL or Cable (256/64 kbps)\0\
 350k Download (VBR) (320/96 kbps)\0\
 350k Surround Stereo (320/192)\0\
 General Mobile Streaming (16/16 kbps)\0\
 General Mobile Local Playback (44/32 kbps)\0\
 PocketPC Local Playback (64/32 kbps)\0\
 Lossless Audio\0"

#define _TRUE (void*)1

static PARAM_DATA prefOverallGeneral[] = {
	{PT_ENUM,0,"Encoder Priority", "priority" ,"Idle\0Lowest\0Lower\0Normal\0", 0},
	{PT_STRING,0,"Media Files Types", "fileTypes", 0, 0, 255},
	{PT_BOOL,0,"Recurse When Adding Directory", "recurse", 0,_TRUE},
	{PT_BOOL,0,"Save Encoding List on Exit", "saveQueue" ,0,_TRUE},
	{PT_BOOL,0,"Enable Logging to File", "logging" ,0,0},
	{PT_FILE,0,"Log File", "logfile" ,"Log Files|*.log\0All Files|*.*\0","mediacoder.log"},
	{PT_BOOL,0,"Enable built-in HTTP server", "httpd" , 0, 0},
	{PT_INT,0,"HTTP deamon port", "httpdPort" ,0,(void*)8109, 0, 0},
	{PT_BOOL,0,"Restrict HTTP server to function locally only", "httpLocalOnly" ,0,_TRUE},
	{PT_BOOL,0,"Check for update at startup", "checkUpdate" ,0,_TRUE},
	{0}
};

static PARAM_DATA prefOverallUI[] = {
	{PT_ENUM,0,"User Interface Mode", "mode", "Simple\0Normal\0Expert\0",(void*)0},
	{PT_BOOL,0,"Show Console Window", "console", 0,0},
	{PT_BOOL,0,"Be more verbose","verbose",0,0},
	{PT_BOOL,0,"Show Pop-up Messages", "popup", 0,_TRUE},
	{PT_ENUM,0,"Show Statistic Window", "stats", "Auto\0Always\0Never\0",0},
	{PT_ENUM,0,"Command Line View", "expertView", "Audio Command\0Video Command\0Container Command\0Console Output\0",0},
	{PT_BOOL,0,"Show Splash on Startup", "splash", 0,_TRUE},
	{PT_STRING,0,"UI Parameters", "param", 0, 0, 64},
	{0}
};

static PARAM_DATA prefOverallTask[] = {
	{PT_ENUM,0,"Transcoding Mode", "mode", "Normal\0Joiner\0", 0, 0},
	{PT_DIR,0,"Output Folder", "destdir", 0,0},
	{PT_DIR,0,"Working Folder", "tempdir", 0,0},
	{PT_BOOL,0,"Automatically create unexistent directories", "autoCreateDir",0,_TRUE},
	{PT_ENUM,0,"Overwriting Action", "overwrite", "Ask\0Overwrite\0Back up existed file and overwrite\0Skip\0",0},
	{PT_BOOL,0,"Keep unfinished file", "keepUnfinished", 0,0},
	{PT_BOOL,0,"Keep intermediate files", "keepTemp", 0,0},
	{PT_BOOL,0,"Delete original files after transcoding", "deleteOriginal", 0,0},
	{PT_BOOL,0,"Power off when all tasks done", "shutdown", 0,0,0},
	{PT_INT,0,"Hanging up timeout (seconds)", "timeout", 0, (void*)10000,0,0},
	{0},
};

static PARAM_DATA prefOverallTag[] = {
	{PT_BOOL,0,"Transfer Tags", "tag", 0,_TRUE},
	{PT_BOOL,0,"Use formatted output file names", "formatting", 0,0},
	{PT_STRING,0,"Output file name format", "fileNameFormat", 0,"$(Artist) - $(Title)", 255},
	{PT_BOOL,0,"Duplicate Directory Structure", "dupDir", 0, 0},
	{0},
};

static PARAM_DATA prefOverallDecoding[] = {
	{PT_INT,0,"Start Time", "startTime", 0,0,0,0},
	{PT_INT,0,"Duration", "duration", 0,0,0,0},
	{PT_STRING,0,"Subtitle Language", "slang", 0,0,7},
	{PT_STRING,0,"Audio Language", "alang", 0,0,7},
	{PT_INT,0,"Audio ID", "aid", 0,0,0,0},
	{PT_INT,0,"Video ID", "vid", 0,0,0,0},
	{PT_ENUM,0,"Number of Playback Channel", "channels", "Default\0\t2\0\t4\0\t6\0",0},
	{PT_FILE,0,"External Audio File", "audioFile", 0,0},
	{PT_INT,0,"Force Sample Rate (0 to disable)", "forceSampleRate", 0, 0,0,0},
	{PT_BOOL,0,"Rebuild AVI index","rebuildAVIIndex",0,0},
	{PT_BOOL,0,"Enable MediaInfo", "mediainfo", 0, _TRUE},
	{0}
};

static PARAM_DATA prefOverallAudio[] = {
	{PT_ENUM,0,"Audio Source", "source", 0,0},
	{PT_ENUM,0,"Audio Encoder", "encoder", 0,0},
	{PT_BOOL,0,"Force Intermediate Waveform File", "useWaveFile", 0,0},
	{PT_BOOL,0,"Transcode all available tracks in container", "allTracks",0,0},
	{PT_INT,0,"Start with audio track ID", "startAID",0,0,0,0},
	{PT_INT,0,"Audio Delay", "delay",0,0,30000,-30000},
	{0}
};

static PARAM_DATA prefOverallVideo[] = {
	{PT_ENUM,0,"Video Encoder", "encoder", 0,0},
	{PT_ENUM,0,"Video Compression Format", "format", "Bypass\0Stream Copy\0XviD\0H.264\0MPEG-1\0MPEG-2\0MPEG-4 (DivX4/5)\0MS-MPEG4-V2\0H.261\0H.263\0H.263+\0Snow\0DivX3\0WMV7\0WMV8\0Flash Video\0Sony DV Video\0Motion JPEG\0Lossless JPEG\0",(void*)2},
	{PT_ENUM,0,"Container Format", "container", 0,0},
	{PT_ENUM,0,"Encode Mode", "mode", "Fixed Bitrate\0Fixed Quality\0Two-Pass\0Three-Pass",0},
	{PT_INT,0,"Bitrate", "bitrate", 0,(void*)800, 8192, 0},
	{PT_INT,0,"Quality", "quality", 0,(void*)50, 100, 1},
	{PT_FLOAT,0,"Output Frame Rate", "fps",0,0,0,0},
	{PT_BOOL,0,"Constant Frame Rate" , "frameSkip" ,0, _TRUE},
	{PT_ENUM,0,"Bitrate Controlling Mode", "bitrateAdjust", "Default\0Adjust by analysis\0By desired stream size\0By compression ratio\0",0},
	{0}
};

static PARAM_DATA prefOverallMPlayer[] = {
	{PT_ENUM,0,"Video Output Device", "vo", "DirectX\0Null\0",0},
	{PT_BOOL,0,"Disable Hardware Video Acceleration", "noAccel", 0,0},
	{PT_INT,0,"Cache Size (KB)", "cache", 0,0,0,0},
	{PT_STRING,0,"Extra MPlayer Options", "options", 0,0,127},
	{PT_DIR,0,"MPlayer Path", "path", 0, ".\\mplayer\\"},
	{0}
};

static PARAM_DATA prefOverallMEncoder[] = {
	{PT_BOOL,0,"Load MEncoder DLL", "dll", 0,0},
	{PT_DIR,0,"MEncoder Path", "path", 0, ".\\mplayer\\"},
	{PT_STRING,0,"Extra MEncoder Options", "options", 0,0,127},
	{0}
};

static PARAM_DATA prefOverall[] = {
	{PT_NODE, prefOverallGeneral, "Generic", "generic"},
	{PT_NODE, prefOverallUI, "User Interface", "ui"},
	{PT_NODE, prefOverallTask, "Task", "task"},
	{PT_NODE, prefOverallTag, "Tagging & Naming", "tagging"},
	{PT_NODE, prefOverallDecoding, "Decoding Options", "decoding"},
	{PT_NODE, prefOverallAudio, "Audio Options", "audio"},
	{PT_NODE, prefOverallVideo, "Video Options", "video"},
	{PT_NODE, prefOverallMPlayer, "MPlayer Options", "mplayer"},
	{PT_NODE, prefOverallMEncoder, "MEncoder Options", "mencoder"},
	{0}
};

static PARAM_DATA prefAudioSourceMPlayer[] = {
	{PT_BOOL,0,"Load MPlayer DLL", "dll", 0, 0},
	{PT_BOOL,0,"Bypass Video Decoding", "bypassVideo", 0, _TRUE},
	{0}
};

static PARAM_DATA prefAudioSourceWinamp[] = {
	{PT_DIR,0,"Plugins Directory", "path", 0,".\\plugins\\"},
	{PT_STRING,0,"Disabled Winamp Input Plugins", "disabledPlugins", 0,0,127},
	{PT_BOOL,0,"Filter Audio with DSP Plugins", "useDspPlugins", 0,0,127},
	{PT_STRING,0,"Enabled DSP Plugins", "enabledDspPlugins", 0,0,127},
	{0}
};

static PARAM_DATA prefAudioSourceLame[] = {
	{0}
};

static PARAM_DATA prefAudioSourceWave[] = {
	{PT_BOOL,0,"Treat as raw PCM", "rawPCM", 0,0},
	{0}
};

static PARAM_DATA prefAudioSources[] = {
	{PT_NODE, prefAudioSourceMPlayer, "MPlayer", "mplayer"},
	{PT_NODE, prefAudioSourceWinamp, "Winamp Input Plugins", "winamp"},
	{PT_NODE, prefAudioSourceLame, "Lame Decoder", "lame"},
	{PT_NODE, prefAudioSourceWave, "Wave/PCM File", "wavefile"},
	{0}
};

static PARAM_DATA prefAudioEncodersLame[] = {
	{PT_INT,0,"Bitrate (ABR/CBR)", "bitrate", 0,(void*)128, 320,16},
	{PT_INT,0,"Quality (VBR)", "quality", 0,(void*)3, 9, 0},
	{PT_INT,0,"Minimum Allowed Bit Rate (VBR)", "minBitrate", 0,(void*)32, 320, 0},
	{PT_INT,0,"Maximum Allowed Bit Rate (VBR)", "maxBitrate", 0,(void*)320, 320, 0},
	{PT_INT,0,"Algorithm Quality", "aq", 0, 0, 9, 0},
	{PT_ENUM,0,"Encoding Mode", "mode", "VBR\0ABR\0CBR\0",0},
	{PT_ENUM,0,"Stereo Mode", "stereo", "Auto\0Stereo\0Joint Stereo\0Dual Channel\0Mono\0",0},
	{PT_ENUM,0,"ReplayGain", "replayGain", "Fast\0Accurate (Slower)\0Disabled\0",0},
	{PT_BOOL,0,"Keep All Frequencies", "allfreq", 0,_TRUE},
	{PT_INT,0,"Low-pass Filter Frequencies (Khz)", "lowpass", 0,0,20000,0},
	{PT_INT,0,"High-pass Filter Frequencies (Khz)", "hipass", 0,0,20000,0},
	{PT_BOOL,0,"Mark as Copyright", "copyright", 0,0},
	{PT_BOOL,0,"Mark as Non-orignal", "nonOriginal", 0,0},
	{PT_BOOL,0,"Error Protection", "protect", 0,0},
	{PT_BOOL,0,"Disable the Bit Reservoir", "nores", 0,0},
	{PT_BOOL,0,"Comply to ISO MPEG Spec", "iso", 0,0},
	{PT_FILE,0,"Path", "path", "Executable Files|*.exe\0",".\\codecs\\lame.exe"},
	{0}
};

static PARAM_DATA prefAudioEncoders3gpp[] = {
	{PT_INT,0,"Bitrate", "bitrate", 0, (void*)32, 48, 10},
	{PT_BOOL,0,"Enable Parametric Stereo", "ps", 0, _TRUE},
	{PT_FILE,0,"3GPP AAC+ Encoder Library Path", "path", "DLL Files|*.dll\0", ".\\codecs\\aacPlusEnc.dll"},
	{0}
};

static PARAM_DATA prefAudioEncodersAmr[] = {
	{PT_ENUM,0,"Codec", "codec", "AMR Narrow Band\0AMR Wide Band\0", (void*)1},
	{PT_INT,0,"Mode", "mode", 0,(void*)7, 9, 0},
	{PT_BOOL,0,"Allow DTX", "dtx", 0, 0},
	{PT_FILE,0,"AMR Encoder Library", "path", "DLL Files|*.dll\0",".\\codecs\\libamr.dll"},
	{0}
};

static PARAM_DATA prefAudioEncodersVorbis[] = {
	{PT_ENUM,0,"Mode", "mode", "Quality\0Bitrate\0",0},
	{PT_INT,0,"Quality", "quality", 0,(void*)275, 1000, 0},
	{PT_INT,0,"Bitrate", "bitrate", 0,(void*)128, 256, 16},
	{PT_INT,0,"Minimum Bit Rate (kbps)", "minBitrate", 0,(void*)0, 256, 0},
	{PT_INT,0,"Maximum Bit Rate (kbps)", "maxBitrate", 0,(void*)0, 256, 0},
	{PT_INT,0,"Resample", "resample", 0,0,0,0},
	{PT_BOOL,0,"Downmix to mono", "downmix", 0,0},
	{PT_FILE,0,"Encoder Path", "path", "Executable Files|*.exe\0",".\\codecs\\oggenc.exe"},
	{0}
};

static PARAM_DATA prefAudioEncodersCT[] = {
	{PT_INT,0,"bitrate", "bitrate", 0,(void*)48, 320, 16},
	{PT_ENUM,0,"Channel Mode", "mode", "Mono\0Stereo\0Stereo Independent\0Parametric Stereo\0Dual Channel",(void*)3},
	{PT_ENUM,0,"AAC Type", "type", "aacPlus\0LC-AAC\0aacPlusHigh\0", 0},
	{PT_ENUM,0,"AAC Version","version","MPEG-2 AAC\0MPEG-4 AAC\0", (void*)1},
	{PT_BOOL,0,"Encode as AAC-V1", "v1", 0,0},
	{PT_FILE,0,"Encoder Path", "path", "DLL Files|*.dll\0", ".\\codecs\\enc_aacplus.dll"},
	{0}
};

static PARAM_DATA prefAudioEncodersNero[] = {
	{PT_ENUM,0,"Format", "format", "Auto\0LC-AAC\0HE-AAC\0HE-AAC V2\0", 0},
	{PT_ENUM,0,"Encoding Mode", "mode", "Target Quality\0Target Bit Rate\0Streaming (CBR)\0",0},
	{PT_INT,0,"Quality", "quality", 0, (void*)30, 100, 1},
	{PT_INT,0,"Bit Rate", "bitrate", 0, (void*)64, 320, 8},
	{PT_BOOL,0,"Hint Track", "hint", 0,0},
	{PT_FILE,0,"Path", "path", "Executable Files|*.exe\0", ".\\codecs\\neroAacEnc.exe"},
	{0}
};

static PARAM_DATA prefAudioEncodersNeroAAC[] = {
	{PT_ENUM,0,"AAC Profile", "profile", "Low-Complexity\0High-Complexity\0",0,0},
	{PT_ENUM,0,"Encoding Mode", "mode", "VBR\0CBR\0",0,0},
	{PT_INT,0,"VBR Quality", "quality", 0,(void*)4, 10, 3},
	{PT_INT,0,"CBR Bitrate", "bitrate", 0,(void*)128, 448, 16},
	{PT_BOOL,0,"High Quality Encoding (Slower)", "hq", 0,_TRUE},
	{PT_BOOL,0,"Downmix to Mono", "downmix", 0,0},
	{PT_BOOL,0,"Create Hint Track for Streaming Server", "hint", 0,0},
	{PT_BOOL,0,"Enable PNS for Very Low Bit Rate", "pns", 0,0},
	{PT_DIR,0,"Nero Plugin Folder", "path", 0,0},
	{0}
};

static PARAM_DATA prefAudioEncodersHelix[] = {
	{PT_ENUM,0,"Audience", "audience", HELIX_AUDIENCES,_TRUE},
	{PT_ENUM,0,"Content Type","type","Music\0Voice\0",0},
	{PT_FILE,0,"Helix Producer Path", "path", "Executable Files|*.exe\0",".\\codecs\\producer\\producer.exe"},
	{0}
};

static PARAM_DATA prefAudioEncodersHelixMP3[] = {
	{PT_ENUM,0,"Encoding Mode", "mode", "VBR\0CBR\0",0},
	{PT_INT,0,"Bit Rate (0 for auto)", "bitrate", 0,(void*)128, 320, 0},
	{PT_INT,0,"VBR Scale", "quality", 0,(void*)100, 150, 0},
	{PT_ENUM,0,"Stereo Mode", "stereo", "Simple Stereo\0Joint Stereo\0Dual Channel\0Mono\0",0},
	{PT_ENUM,0,"Number of Subbands (mode-1 only)", "subbands", "Default\0Auto\0\t4\0\t8\0\t12\0\t16\0",0},
	{PT_ENUM,0,"Input Filtering", "filtering", "Auto\0No filtering\0DC blocking filter\0",0},
	{PT_ENUM,0,"High Frequency Encoding (allows coding >16Khz)", "highFreq", "Disabled\0Mode-1 Granules\0All Granules\0",0},
	{PT_BOOL,0,"Using SSE instructions", "sse", 0,_TRUE},
	{PT_STRING,0,"Extra Options", "options", 0,0,127},
	{PT_FILE,0,"Encoder Path", "path", "Executable Files|*.exe\0",".\\codecs\\hmp3.exe"},
	{0}
};

static PARAM_DATA prefAudioEncodersFaac[] = {
	{PT_ENUM,0,"Mode", "mode", "Quality\0Bitrate\0",0},
	{PT_INT,0,"Quality", "quality", 0,(void*)100, 500, 10},
	{PT_INT,0,"Bitrate", "bitrate", 0,(void*)128, 256, 16},
	{PT_ENUM,0,"AAC Object Type", "objectType", "Low Complexity\0Main\0SSR\0Long Term Prediction\0",0},
	{PT_ENUM,0,"MPEG Version", "version", "MPEG-2\0MPEG-4\0",_TRUE},
	{PT_BOOL,0,"Temporal Noise Shaping", "tns", 0,_TRUE},
	{PT_BOOL,0,"Don't use mid/side coding", "noMidSide", 0,0},
	{PT_ENUM,0,"Enable Block Type", "blockType", "Both\0No Short\0No Long\0",0},
	{PT_FILE,0,"Path", "path", "Executable Files|*.exe\0",".\\codecs\\faac.exe"},
	{0}
};

static PARAM_DATA prefAudioEncodersiTunes[] = {
	{PT_BOOL,0,"Keep Encoded File in iTunes Album", "keepFiles", 0,0},
	{PT_FILE,0,"Encoder Path", "path", "Executable Files|*.exe\0",".\\codecs\\iTunesEncode.exe"},
	{0}
};

static PARAM_DATA prefAudioEncodersWMA[] = {
	{PT_ENUM,0,"Codec", "codec", "Windows Media Audio 9\0Windows Media Audio 9 Voice\0Windows Media Audio 9 Lossless\0",0},
	{PT_ENUM,0,"Encoding Mode", "mode", "One-Pass CBR\0Two-Pass CBR\0Quality-Based VBR\0Bitrate-Based VBR (2-pass)\0Bitrate-Based Peak VBR (2-pass)\0",(void*)2},
	{PT_ENUM,0,"Quality", "quality", "Q10\0Q25\0Q50\0Q75\0Q90\0Q100\0",(void*)2},
	{PT_INT,0,"Bitrate", "bitrate", 0,(void*)64,320,0},
	{PT_DIR,0,"Path of Windows Media Encoder", "path", 0,".\\codecs\\"},
	{0}
};

static PARAM_DATA prefAudioEncodersMusepack[] = {
	{PT_ENUM,0,"Profile", "profile", "Telephone (32~48Kbps)\0Thumb (58~86Kbps)\0Radio (112~152Kbps)\0Standard (142~184Kbps)\0Extreme (168~212Kbps)\0Insane (232~268Kbps)\0Braindead (232~278Kbps)",(void*)3},
	{PT_FILE,0,"Encoder Path", "path", "Executable Files|*.exe\0",".\\codecs\\mppenc.exe"},
	{0}
};

static PARAM_DATA prefAudioEncodersWavpack[] = {
	{PT_BOOL,0,"Best Compression", "best", 0,_TRUE},
	{PT_BOOL,0,"Enable Hybrid Compression", "hybrid", 0,0},
	{PT_INT,0,"Hybrid Compression Bit Rate (kbps)", "bitrate", 0,(void*)320, 9600, 24},
	{PT_BOOL,0,"Create Correction File", "correction", 0,0},
	{PT_INT,0,"Extra Encode Processing", "extra", 0,0,6,0},
	{PT_FILE,0,"Encoder Path", "path", "Executable Files|*.exe\0",".\\codecs\\wavpack.exe"},
	{PT_STRING,0,"Extra Options", "options", 0,0,31},
	{0}
};

static PARAM_DATA prefAudioEncodersFLAC[] = {
	{PT_INT,0,"Compression Level", "level", 0,(void*)8, 8, 0},
	{PT_BOOL,0,"Exhaustive model search", "exhaustive", 0,0},
	{PT_INT,0,"Maximum LPC order", "maxlpc", 0, 0, 32, 0},
	{PT_BOOL,0,"Verify Encoding", "verify", 0,0},
	{PT_FILE,0,"Encoder Path", "path", "Executable Files|*.exe\0",".\\codecs\\flac.exe"},
	{PT_STRING,0,"Extra Options", "options", 0,0,31},
	{0}
};

static PARAM_DATA prefAudioEncodersAPE[] = {
	{PT_ENUM,0,"Compression Level", "level", "Fast\0Normal\0High\0Extra High\0Insane\0",(void*)3},
	{PT_FILE,0,"MACDLL Path", "path", "DLL Files|*.dll\0",".\\codecs\\MACDll.dll"},
	{0}
};

static PARAM_DATA prefAudioEncodersAls[] = {
	{PT_BOOL,0,"Adaptive prediction order", "adaptive", 0, _TRUE},
	{PT_BOOL,0,"Independent stereo coding", "dualStereo", 0, 0},
	{PT_BOOL,0,"Long term prediction", "ltp", 0, 0},
	{PT_INT,0,"Prediction order", "predictionOrder", 0, (void*)10,1023,0},
	{PT_ENUM,0,"RLSMLS mode", "rlsmls", "No RLSMLS mode\0Quick\0Medium\0Best\0", 0},
	{PT_FILE,0,"Encoder Path", "path", "Executable Files|*.exe\0",".\\codecs\\mp4als.exe"},
	{0}
};

static PARAM_DATA prefAudioEncodersOfr[] = {
	{PT_ENUM,0,"Optimization", "optimize", "None\0Fast\0Normal\0High\0Best\0", (void*)4},
	{PT_FILE,0,"Encoder Path", "path", "Executable Files|*.exe\0",".\\codecs\\ofr.exe"},
	{0}
};

static PARAM_DATA prefAudioEncodersPCM[] = {
	{PT_ENUM,0,"Output Format", "format", "Waveform File\0Raw PCM File\0", 0},
	{0}
};

static PARAM_DATA prefAudioEncodersCLI[] = {
	{PT_BOOL,0,"Standard input as audio data input", "stdin", 0,_TRUE},
	{PT_BOOL,0,"Raw PCM Data (Without wave header)", "pcm", 0,_TRUE},
	{PT_STRING,0,"File Extension Name", "fileext", 0,"mp3",7},
	{PT_STRING,0,"Command Line", "command", 0,"lame \"$(SourceFile)\" \"$(DestFile)\"",255},
	{0}
};

static PARAM_DATA prefAudioEncodersFFMPEG[] = {
	{PT_ENUM,0,"Audio Codec", "codec", "MPEG Layer 2\0MPEG Layer 3\0AC3\0AMR Narrow Band\0AMR Wide Band\0IMA Adaptive PCM\0Sonic\0",0},
	{PT_INT,0,"Audio Bit Rate (kbps)", "bitrate", 0,(void*)224,1024,0},
	{PT_INT,0,"Sample Rate (0 for original)", "samplerate", 0,0,48000,8000},
	{PT_FILE,0,"FFMPEG Path", "path", "Executable Files|*.exe\0",".\\codecs\\ffmpeg.exe"},
	{PT_STRING,0,"Extra Options", "options", 0,0,63},
	{0}
};

static PARAM_DATA prefAudioEncoders[] = {
	{PT_NODE, prefAudioEncodersLame, "Lame", "lame"},
	{PT_NODE, prefAudioEncoders3gpp, "3GPP AAC Plus Encoder", "aac3gpp"},
	{PT_NODE, prefAudioEncodersAmr, "AMR", "amr"},
	{PT_NODE, prefAudioEncodersVorbis, "Ogg/Vorbis", "vorbis"},
	{PT_NODE, prefAudioEncodersCT, "CT AAC+ Encoder", "aacplus"},
	{PT_NODE, prefAudioEncodersNero, "Nero Reference Encoder", "nero"},
	{PT_NODE, prefAudioEncodersNeroAAC, "Nero AAC Encoder", "neroaac"},
	{PT_NODE, prefAudioEncodersHelix, "Helix Producer", "helix"},
	{PT_NODE, prefAudioEncodersHelixMP3, "Helix MP3 Encoder", "helixmp3"},
	{PT_NODE, prefAudioEncodersFaac, "FAAC", "faac"},
	{PT_NODE, prefAudioEncodersiTunes, "iTunesEncode", "itunes"},
	{PT_NODE, prefAudioEncodersWMA, "Windows Media Audio", "wma"},
	{PT_NODE, prefAudioEncodersMusepack, "MusePack", "musepack"},
	{PT_NODE, prefAudioEncodersFFMPEG, "FFMPEG Audio Encoder", "ffmpeg"},
	{PT_NODE, prefAudioEncodersWavpack, "WavPack", "wavpack"},
	{PT_NODE, prefAudioEncodersFLAC, "Free Lossless Audio Codec", "flac"},
	{PT_NODE, prefAudioEncodersAPE, "Monkey's Audio (APE)", "ape"},
	{PT_NODE, prefAudioEncodersAls, "AAC Lossless", "als"},
	{PT_NODE, prefAudioEncodersOfr, "OptimFrog", "ofr"},
	{PT_NODE, prefAudioEncodersPCM, "Waveform/PCM", "pcm"},
	{PT_NODE, prefAudioEncodersCLI, "Generic CLI Encoder", "cli"},
	{0}
};

static PARAM_DATA prefVideoEncodersXvid[] = {
	{PT_ENUM,0,"Profile", "profile", "Unrestricted\0Simple Profile Level 0\0Simple Profile Level 1\0Simple Profile Level 2\0Simple Profile Level 3\0Advanced Simple Profile Level 0\0Advanced Simple Profile Level 1\0Advanced Simple Profile Level 2\0Advanced Simple Profile Level 3\0Advanced Simple Profile Level 4\0Advanced Simple Profile Level 5\0DXN Handheld Profile\0DXN Portable NTSC Profile\0DXN Portable PAL Profile\0DXN Home Theater NTSC Profile\0DXN Home Theater PAL Profile\0DXN HDTV Profile\0",0},
	{PT_BOOL,0,"Strict Profile Conformation", "strict", 0,0},
	{PT_INT,0,"Maximum B-frames between I/P-frames", "bframe", 0, (void*)2,4,0},
	{PT_INT,0,"Motion Estimation Quality", "meQuality", 0,(void*)6,6,0},
	{PT_BOOL,0,"Interlaced Video Content", "interlaced", 0,0},
	{PT_BOOL,0,"Greyscale", "greyscale", 0,0},
	{PT_BOOL,0,"Quarter Pixel Precision", "qpel", 0,0},
	{PT_BOOL,0,"Global Motion Compensation", "gmc", 0, 0},
	{PT_BOOL,0,"Adaptive Quantization", "trellis", 0, _TRUE},
	{PT_BOOL,0,"Optimize for Cartoons", "cartoon", 0,0},
	{PT_ENUM,0,"Quantitizer Type", "quantType", "H.263\0MPEG\0",0},
	{PT_BOOL,0,"Using the Chroma Planes", "chroma_me", 0, _TRUE},
	{PT_BOOL,0,"Enable a Chroma Optimizer Prefilter", "chroma_opt", 0, _TRUE},
	{PT_BOOL,0,"High Quality AC Coefficient Prediction", "hqac", 0, _TRUE},
	{PT_ENUM,0,"Motion Search Algorithm", "vhq", "Off\0Mode Decision\0Limited Search\0Medium Search\0Wide Search\0", 0},
	{PT_BOOL,0,"Frame Packed", "packed", 0,0},
	{PT_BOOL,0,"Turbo Mode (2-pass)", "turbo", 0, _TRUE},
	{PT_BOOL,0,"Using DX50 ffourcc", "dx50", 0, 0},
	{PT_INT,0,"Threads", "threads", 0, (void*)1,4,1},
	{PT_STRING,0,"Extra Options","options", 0,0,63,0},
	{0}
};

static PARAM_DATA prefVideoEncodersX264[] = {
	//{PT_ENUM,0,"Profile", "Profile", "Unrestricted\0Baseline\0Extended\0Main\0High\0High 10\0High 4:2:2\0", 0},
	{PT_INT,0,"Level of bitstream", "level", 0, 0, 0,0},
	{PT_BOOL,0,"Preserve more details (less compression)","moreDetails",0,0},
	{PT_ENUM,0,"Turbo Mode", "TurboMode", "Disabled\0Reduce subq\0Reduce subq and frameref to 1\0",_TRUE},
	{PT_ENUM,0,"Fullpixel motion estimation algorithm", "me", "Diamond search, radius 1 (fast)\0Hexagon search, radius 2\0Uneven multi-hexagon search\0Exhaustive search (very slow)\0",(void*)2},
	{PT_INT,0,"Motion search radius", "meRange", 0,(void*)24, 64, 4},
	{PT_INT,0,"Subpel refinement quality", "subq", 0,(void*)5, 7, 1},
	{PT_INT,0,"Maximum B frames between I and P frames", "bframes", 0,(void*)3, 16, 0},
	{PT_BOOL,0,"Adaptive B frame number","badapt",0,_TRUE},
	{PT_INT,0,"Maximum interval between IDR-frames", "keyint", 0, (void*)250,0,0},
	{PT_INT,0,"Minimum interval between IDR-frames", "keyint_min", 0, (void*)25,0,0},
	{PT_INT,0,"Frames used as predictors in B and P frames", "frameref", 0, (void*)1, 16, 1},
	{PT_INT,0,"P frame Quantitizer", "qpconstant", 0,(void*)26, 51, 0},
	{PT_INT,0,"Minimum quantizer", "qpmin", 0, (void*)10, 51, 1},
	{PT_INT,0,"Maximum quantizer", "qpmax", 0, (void*)51, 51, 1},
	{PT_INT,0,"Quantizer step", "qpstep", 0, (void*)2, 50, 0},
	{PT_INT,0,"Quantizer compression", "qcomp", 0, (void*)60, 100, 0},
	{PT_BOOL,0,"Use Context-Adaptive Binary Arithmetic Coding", "cabac", 0, _TRUE},
	{PT_INT,0,"Maximum local bitrate", "vbvMaxRate", 0, 0,0,0},
	{PT_INT,0,"Averaging period for maximum local bitrate", "vbvBufSize", 0, 0,0,0},
	{PT_ENUM,0,"Direct macroblocks prediction", "directPredict", "None\0Spatial\0Temporal\0Auto\0", (void*)1},
	{PT_BOOL,0,"Use weighted prediction in B-frames", "weightedPredict", 0, _TRUE},
	{PT_BOOL,0,"Use macroblock type i4x4","i4x4",0,_TRUE},
	{PT_BOOL,0,"Use macroblock type i8x8","i8x8",0,_TRUE},
	{PT_BOOL,0,"Use macroblock types b16x8, b8x16, b8x8","b8x8mv",0,_TRUE},
	{PT_BOOL,0,"Use macroblock types p16x8, p8x16, p8x8","p8x8mv",0,_TRUE},
	{PT_BOOL,0,"Use macroblock types p8x4, p4x8, p4x4","p4x4mv",0,0},
	{PT_BOOL,0,"Adaptive spatial transform size","p8x8dct",0,_TRUE},
	{PT_BOOL,0,"Mixed reference frame","mixedReference",0,_TRUE},
	{PT_BOOL,0,"Rate-distortion optimization of B-frames macroblock types","brdo",0,0},
	{PT_ENUM,0,"Rate-distortion optimal quantization","trellis","Disabled\0Enabled only for the final encode\0Enabled during all mode decisions\0",(void*)1},
	{PT_BOOL,0,"Refine motion vectors used in bidirectional macroblocks","bime",0,_TRUE},
	{PT_BOOL,0,"Performs early skip detection in P-frames","fastPSskip",0,_TRUE},
	{PT_INT,0,"Threads", "threads", 0, (void*)1,4,1},
	{PT_STRING,0,"Extra Options", "options", 0,0,63},
	{0}
};

static PARAM_DATA prefVideoEncodersFFMPEG[] = {
	{PT_ENUM,0,"Macroblock decision algorithm", "mbd", "Use mbcmp\0Fewest bits\0Best rate distortion\0",_TRUE},
	{PT_BOOL,0,"Allow 4 motion vectors per macroblock", "v4mv", 0,0},
	{PT_BOOL,0,"Overlapped block motion compensation (H.263)", "obmc", 0,0},
	{PT_BOOL,0,"Use quarter pel motion compensation", "qpel", 0, 0},
	{PT_INT,0,"Subpel refinement quality (for qpel)", "subq", 0, (void*)8, 8, 1},
	{PT_BOOL,0,"Trellis searched quantization", "trellis", 0,_TRUE},
	{PT_INT,0,"Noise reduction", "nr", 0,0, 600, 0},
	{PT_ENUM,0,"Quantizer noise shaping", "qns", "Disabled\0Mode 1\0Mode 2\0Mode 3\0",0},
	{PT_BOOL,0,"Activate high quality settings", "hq", 0, 0},
	{PT_INT,0,"Maximum interval between keyframes in frames", "KeyInt", 0, (void*)250, 300, 0},
	{PT_INT,0,"Minimum bitrate in kbit/sec (0 for unlimited)", "vrcMinRate", 0, 0, 8000, 0},
	{PT_INT,0,"Maximum bitrate in kbit/sec (0 for unlimited)", "vrcMaxRate", 0, 0, 16000, 0},
	{PT_INT,0,"Buffer size in Kbit (0 for unlimited)", "vrcBufSize", 0, 0,0,0},
	{PT_ENUM,0,"Force Aspect Ratio", "aspect", "None\0\t4/3\0\t16/9\0\t2/1\0", 0},
	{PT_STRING,0,"Extra Options", "options", 0,0,63},
	{0}
};

static PARAM_DATA prefVideoEncoders[] = {
	{PT_NODE, prefVideoEncodersXvid, "XviD" ,"xvid",},
	{PT_NODE, prefVideoEncodersX264, "X264", "x264"},
	{PT_NODE, prefVideoEncodersFFMPEG, "FFMPEG", "ffmpeg"},
	{0}
};

static PARAM_DATA prefContainersMatroska[] = {
	{PT_FILE,0,"Path", "path", "Executable Files|*.exe\0",".\\tools\\mkvmerge.exe"},
	{PT_STRING,0,"Extra Matroska Options", "options", 0,0,127},
	{0}
};

static PARAM_DATA prefContainersMP4Box[] = {
	{PT_BOOL,0,"Packed bitstream when importing raw ASP", "packed", 0,0},
	{PT_BOOL,0,"Forces backward compatible AAC-SBR", "sbr", 0,0},
	{PT_BOOL,0,"Forces non-backward compatible AAC-SBR", "sbrx", 0,0},
	{PT_BOOL,0,"Keeps all MPEG-4 Systems info", "keepSystemInfo", 0,0},
	{PT_BOOL,0,"Forces MPEG-4 sample descriptions (3GPP2)", "sampleDesc", 0,0},
	{PT_BOOL,0,"Rewrites the file as an ISMA 1.0 AV file", "isma", 0,0},
	{PT_BOOL,0,"Rewrites as 3GPP(2) file", "rewrite3gp", 0,0},
	{PT_FILE,0,"Path", "path", "Executable Files|*.exe\0",".\\tools\\mp4box.exe"},
	{PT_STRING,0,"Extra MP4Box Options", "options", 0,0,127},
	{0}
};

static PARAM_DATA prefContainersPMP[] = {
	{PT_FILE,0,"Path", "path", "Executable Files|*.exe\0",".\\tools\\pmp_muxer.exe"},
	{0}
};

static PARAM_DATA prefContainersMPEG[] = {
	{PT_ENUM,0,"Format", "format", "MPEG-1\0MPEG-2\0VCD\0SVCD\0DVD\0",0},
	{0}
};

static PARAM_DATA prefContainersLAVF[] = {
	{PT_ENUM,0,"Format", "format", "MPEG\0ASF\0AVI\0MP4\0RealMedia\0QuickTime MOV\0Flash Video\0Sony Digital Video",0},
	{0}
};

static PARAM_DATA prefContainersAvi[] = {
	{0}
};

static PARAM_DATA prefContainers[] = {
	{PT_NODE, prefContainersAvi, "AVI Options", "avi"},
	{PT_NODE, prefContainersMatroska, "Matroska Options", "matroska"},
	{PT_NODE, prefContainersMP4Box, "MP4Box Options", "mp4box"},
	{PT_NODE, prefContainersMPEG, "MPEG Options", "mpeg"},
	{PT_NODE, prefContainersLAVF, "LAVF Options", "lavf"},
	{PT_NODE, prefContainersPMP, "PMP Muxer Options", "pmpmuxer"},
	{0}
};

static PARAM_DATA prefAudioFiltersInternal[] = {
	{PT_ENUM,0,"Stereo Downmix", "downmix", "Disabled\0Left Channel\0Right Channel\0Average\0",(void*)0},
	{0}
};

static PARAM_DATA prefAudioFiltersSSRC[] = {
	{PT_BOOL,0,"Enabled", "enabled", 0, 0},
	{PT_BOOL,0,"Two-Pass Mode", "twopass", 0, _TRUE},
	{PT_FLOAT,0,"Output Sampling Frequency (0 for original)", "samplerate", 0,0},
	{PT_BOOL,0,"Normalization", "normalization",0,_TRUE},
	{PT_BOOL,0,"Convert to 16-bit samples", "bits", 0, 0, 0},
	{PT_ENUM,0,"Dithering", "dithering", "Default\0No Dither\0No Noise Shaping\0Triangular Spectral Shape\0ATH based noise shaping\0Dither Amplitude < Type 3\0",0},
	{PT_FILE,0,"Path","path","Executable Files|*.exe\0",".\\tools\\ssrc.exe"},
	{0}
};

static PARAM_DATA prefAudioFiltersResampling[] = {
	{PT_INT,0,"Output Sampling Rate (0 for original)", "samplerate",0,0,48000,0},
	{PT_BOOL,0,"Down Sampling Only", "downSamplingOnly", 0,0},
	{PT_BOOL,0,"High Precious Resampling", "precious", 0,_TRUE},
	{PT_ENUM,0,"Resampling Method", "method", "Linear Interpolation\0Polyphase Filterbank (integer)\0Polyphase Filterbank (float point)\0",0},
	{0}
};

static PARAM_DATA prefAudioFiltersEqualizer[] = {
	{PT_BOOL,0,"Enabled", "enabled", 0,0},
	{PT_INT,0,"31.25 Hz", "band0", 0,0,12,-12},
	{PT_INT,0,"62.5 Hz", "band1", 0,0,12,-12},
	{PT_INT,0,"125 Hz", "band2", 0,0,12,-12},
	{PT_INT,0,"250 Hz", "band3", 0,0,12,-12},
	{PT_INT,0,"500 Hz", "band4", 0,0,12,-12},
	{PT_INT,0,"1000 Hz", "band5", 0,0,12,-12},
	{PT_INT,0,"2000 Hz", "band6", 0,0,12,-12},
	{PT_INT,0,"4000 Hz", "band7", 0,0,12,-12},
	{PT_INT,0,"8000 Hz", "band8", 0,0,12,-12},
	{PT_INT,0,"16000 Hz", "band9", 0,0,12,-12},
	{0}
};

static PARAM_DATA prefAudioFiltersChannels[] = {
	{PT_BOOL,0,"Enabled", "enabled", 0,0},
	{PT_INT,0,"Number of channels", "channelNum", 0,(void*)2, 6, 1},
	{PT_ENUM,0,"Source of Channel 0", "channel0", "None\0Channel 0\0Channel 1\0Channel 2\0Channel 3\0Channel 4\0Channel 5\0",_TRUE},
	{PT_ENUM,0,"Source of Channel 1", "channel1", "None\0Channel 0\0Channel 1\0Channel 2\0Channel 3\0Channel 4\0Channel 5\0",(void*)2},
	{PT_ENUM,0,"Source of Channel 2", "channel2", "None\0Channel 0\0Channel 1\0Channel 2\0Channel 3\0Channel 4\0Channel 5\0",0},
	{PT_ENUM,0,"Source of Channel 3", "channel3", "None\0Channel 0\0Channel 1\0Channel 2\0Channel 3\0Channel 4\0Channel 5\0",0},
	{PT_ENUM,0,"Source of Channel 4", "channel4", "None\0Channel 0\0Channel 1\0Channel 2\0Channel 3\0Channel 4\0Channel 5\0",0},
	{PT_ENUM,0,"Source of Channel 5", "channel5", "None\0Channel 0\0Channel 1\0Channel 2\0Channel 3\0Channel 4\0Channel 5\0",0},
	{0}
};

static PARAM_DATA prefAudioFiltersVolume[] = {
	{PT_FLOAT,0,"Desired Gain in dB", "gain", 0,0,60,-200},
	{PT_BOOL,0,"Volume Normalization", "normalization", 0,0},
	{PT_BOOL,0,"Enable Soft-clipping", "clipping", 0,_TRUE},
	{0}
};

static PARAM_DATA prefAudioFiltersSurround[] = {
	{PT_FLOAT,0,"Delay time in ms for the rear speakers", "delay", 0,0,1000,0},
	{0}
};

static PARAM_DATA prefAudioFiltersDelay[] = {
	{PT_BOOL,0,"Enabled", "enabled", 0,0},
	{PT_FLOAT,0,"Delay of Channel 0", "channel0", 0,0,1000,0},
	{PT_FLOAT,0,"Delay of Channel 1", "channel1", 0,0,1000,0},
	{PT_FLOAT,0,"Delay of Channel 2", "channel2", 0,0,1000,0},
	{PT_FLOAT,0,"Delay of Channel 3", "channel3", 0,0,1000,0},
	{PT_FLOAT,0,"Delay of Channel 4", "channel4", 0,0,1000,0},
	{PT_FLOAT,0,"Delay of Channel 5", "channel5", 0,0,1000,0},
	{0}
};

static const float diffco = 2.5;
static PARAM_DATA prefAudioFiltersExtraStereo[] = {
	{PT_BOOL,0,"Enabled", "enabled", 0,0},
	{PT_FLOAT,0,"Difference Coefficient", "coeff", 0,(void*)&diffco,10,-1},
	{0}
};

static PARAM_DATA prefAudioFiltersCompressor[] = {
	{PT_BOOL,0,"Enabled", "enabled", 0,0},
	{0}
};

static PARAM_DATA prefAudioFilters[] = {
	{PT_NODE,prefAudioFiltersInternal,"Internal Filters","internal",0,0},
	{PT_NODE,prefAudioFiltersSSRC,"Shibatch Sample Rate Converter", "shibatch", 0,0},
	{PT_NODE,prefAudioFiltersResampling,"Resampling", "resample", 0,0},
	{PT_NODE,prefAudioFiltersEqualizer,"Equalizer", "equalizer", 0,0},
	{PT_NODE,prefAudioFiltersChannels,"Channels", "channels", 0,0},
	{PT_NODE,prefAudioFiltersVolume,"Volume", "volume", 0,0},
	{PT_NODE,prefAudioFiltersSurround,"Surround", "surround", 0,0},
	{PT_NODE,prefAudioFiltersCompressor,"Compressor/Expander", "compressor", 0,0},
	{PT_NODE,prefAudioFiltersDelay,"Delay", "delay"},
	{PT_NODE,prefAudioFiltersExtraStereo,"Extra Stereo", "extraStereo", 0,0},
	{0}
};

static PARAM_DATA prefVideoFiltersPostProc[] = {
	{PT_ENUM,0,"Mode", "mode", "Disabled\0Full\0Chorminace Only\0Luminance Only\0",0},
	{PT_BOOL,0,"Horizontal Deblocking", "hdeblock", 0, _TRUE},
	{PT_BOOL,0,"Vertical Deblocking", "vdeblock", 0, _TRUE},
	{PT_BOOL,0,"Deringing", "dering", 0, 0},
	{PT_BOOL,0,"Auto Level", "level", 0, _TRUE},
	{PT_ENUM,0,"Deinterlacing", "deint", "Disabled\0Linear blend\0Linear interpolating\0Cubic interpolating\0Median deinterlacing\0FFmpeg deinterlacing filter\0Vertically applied FIR lowpass\0",0},
	{PT_BOOL,0,"Temporal Denoiser", "denoiser", 0,0},
	{0}
};

static PARAM_DATA prefVideoFiltersScale[] = {
	{PT_BOOL,0,"Enabled", "enabled", 0,0},
	{PT_ENUM,0,"Scale to Preset Size", "preset", "Use Custom Settings\0\t768x576\0\t720x576\0\t720x480\0\t640x480\0\t624x352\0\t608x336\0\t512x384\0\t480x272\0\t352x576\0\t352x480\0\t352x288\0\t352x240\0\t320x240\0\t320x160\0\t208x176\0\t176x208\0\t176x144\0\t160x128\0\t160x96\0\t128x96\0\t128x64\0",0},
	{PT_INT,0,"Width (0 for original)", "width", 0,0},
	{PT_INT,0,"Height (0 for original)", "height", 0,0},
	{PT_BOOL,0,"Interlaced Scaling", "interlaced", 0,0},
	{PT_ENUM,0,"Chroma Skipping", "chroma", "Use all available input lines for chroma\0Use only every 2. input line for chroma\0Use only every 4. input line for chroma\0Use only every 8. input line for chroma\0",0,0},
	{PT_ENUM,0,"Scale Algorithm", "algorithm", "Default\0VirtualDub's \"Precise Bicubic\"\0Catmull-Rom Spline\0Mitchell-Netravali Spline\0Cubic B-Spline\0", 0},
	{0}
};

static PARAM_DATA prefVideoFiltersExpand[] = {
	{PT_BOOL,0,"Enabled", "enabled", 0,0},
	{PT_INT,0,"Width", "width", 0,0},
	{PT_INT,0,"Height", "height", 0,0},
	{PT_INT,0,"X Position", "x", 0,0},
	{PT_INT,0,"Y Position", "y", 0,0},
	{PT_BOOL,0,"OSD/Subtitle Rendering", "osd", 0,_TRUE},
	{PT_ENUM,0,"Force Aspect Ratio", "aspect", "Disabled\0\t4:3\0\t16:9\0\t2:1\0",0},
	{0}
};

static PARAM_DATA prefVideoFiltersCrop[] = {
	{PT_BOOL,0,"Enabled", "enabled", 0,0},
	{PT_INT,0,"Left (0 for center)", "left", 0,0,0,0},
	{PT_INT,0,"Top (0 for center)", "top", 0,0,0,0},
	{PT_INT,0,"Width (0 for original)", "width", 0,0,0,0},
	{PT_INT,0,"Height (0 for original)", "height", 0,0,0,0},
	{PT_INT,0,"Crop detect limit ", "detectLimit", 0,(void*)16, 255, 0},
	{0}
};

static PARAM_DATA prefVideoFiltersRotate[] = {
	{PT_ENUM,0,"Mode","mode","Disabled\090 degrees CW & flip\090 degrees CW\090 degrees CCW\090 degrees CCW & flip\0",0},
	{0}
};

static PARAM_DATA prefVideoFiltersDenoise[] = {
	{PT_ENUM,0,"Mode", "mode", "Disabled\0Normal\0High Quality\0",0},
	{PT_INT,0,"Spatial Luma Strength", "luma", 0,(void*)4,0,0},
	{PT_INT,0,"Spatial Chroma Strength", "chroma", 0,(void*)3,0,0},
	{PT_INT,0,"Temporal Strength", "strength", 0,(void*)6,0,0},
	{0}
};

static PARAM_DATA prefVideoFiltersScreenshot[] = {
	{PT_BOOL,0,"Enabled", "enabled", 0,0},
	{0}
};

static PARAM_DATA prefVideoFiltersExtra[] = {
	{PT_STRING,0,"Extra video filter options", "options", 0,0, 127},
	{0}
};

static PARAM_DATA prefVideoFilters[] = {
	{PT_NODE,prefVideoFiltersScale,"Scaling", "scale"},
	{PT_NODE,prefVideoFiltersCrop,"Cropping", "crop"},
	{PT_NODE,prefVideoFiltersPostProc,"Post-Processing", "postproc"},
	{PT_NODE,prefVideoFiltersExpand,"Expanding", "expand"},
	{PT_NODE,prefVideoFiltersRotate,"Rotating","rotate"},
	{PT_NODE,prefVideoFiltersDenoise,"De-Noise 3D", "denoise"},
	{PT_NODE,prefVideoFiltersScreenshot,"Screenshot", "screenshot"},
	{PT_NODE,prefVideoFiltersExtra,"Extra", "extra"},
	{0}
};

PARAM_DATA prefParams[]={
	{PT_CATALOG, prefOverall, "Overall", "overall"},
	{PT_CATALOG, prefAudioSources, "Audio Sources", "audiosrc"},
	{PT_CATALOG, prefAudioEncoders, "Audio Encoders", "audioenc"},
	{PT_CATALOG, prefVideoEncoders, "Video Encoders", "videoenc"},
	{PT_CATALOG, prefContainers, "Container", "container"},
	{PT_CATALOG, prefAudioFilters, "Audio Filters", "audiofilter"},
	{PT_CATALOG, prefVideoFilters, "Video Filters", "videofilter"},
	{0},
};
	
PARAM_DATA prefHead = {PT_ROOT, prefParams};

PARAM_DATA* nodeList[] = {
	prefOverallGeneral,
	prefOverallUI,
	prefOverallTask,
	prefOverallTag,
	prefOverallDecoding,
	prefOverallAudio,
	prefOverallVideo,
	prefOverallMPlayer,
	prefOverallMEncoder,
	prefAudioSourceMPlayer,
	prefAudioSourceWinamp,
	prefAudioSourceLame,
	prefAudioSourceWave,
	prefAudioEncodersLame,
	prefAudioEncoders3gpp,
	prefAudioEncodersAmr,
	prefAudioEncodersVorbis,
	prefAudioEncodersCT,
	prefAudioEncodersNero,
	prefAudioEncodersNeroAAC,
	prefAudioEncodersHelix,
	prefAudioEncodersHelixMP3,
	prefAudioEncodersFaac,
	prefAudioEncodersiTunes,
	prefAudioEncodersWMA,
	prefAudioEncodersMusepack,
	prefAudioEncodersFFMPEG,
	prefAudioEncodersWavpack,
	prefAudioEncodersFLAC,
	prefAudioEncodersAPE,
	prefAudioEncodersAls,
	prefAudioEncodersOfr,
	prefAudioEncodersPCM,
	prefAudioEncodersCLI,
	prefVideoEncodersXvid,
	prefVideoEncodersX264,
	prefVideoEncodersFFMPEG,
	prefContainersMatroska,
	prefContainersMP4Box,
	prefContainersMPEG,
	prefContainersLAVF,
	prefContainersPMP,
	prefAudioFiltersInternal,
	prefAudioFiltersSSRC,
	prefAudioFiltersResampling,
	prefAudioFiltersEqualizer,
	prefAudioFiltersChannels,
	prefAudioFiltersVolume,
	prefAudioFiltersSurround,
	prefAudioFiltersCompressor,
	prefAudioFiltersDelay,
	prefAudioFiltersExtraStereo,
	prefVideoFiltersScale,
	prefVideoFiltersCrop,
	prefVideoFiltersExpand,
	prefVideoFiltersRotate,
	prefVideoFiltersPostProc,
	prefVideoFiltersDenoise,
	prefVideoFiltersScreenshot,
	0
};


PARAM_DESC prefInfo[] = {
/*
	{PI_OVERALL, "Overall settings"},
	{PI_PAGE_ADEC, "Settings of audio sources"},
	{PI_PAGE_AENC, "Settings of audio encoders"},
	{PI_AF, "Audio filters allow you to modify the audio stream and its properties. (Appliable with MPlayer source only)"},
	{PI_VF, "Video filters allow you to modify the video stream and its properties."},
	{"overall.task.destdir", "All encoded files will be put in this folder"},
	{"overall.task.tempdir", "All temporary files will be created in this folder"},
	{PI_FILE_TYPES, "Types of files to include when adding a folder"},
	{PI_ME_OPTS, "Extra options to pass to MEncoder"},
	{PI_BITRATE_ADJUST, "Automatically adjust video bitrate in several ways."},
	{PI_XVID_MQ, "This option controls the motion estimation subsystem. The higher the value, the more precise the estimation should be (default: 6). The more precise the motion estimation is, the more bits can be saved. Precision is gained at the expense of CPU time so decrease this setting if you need realtime encoding."},
	{PI_XVID_INTERLACE, "Encode the fields of interlaced video material. Turn this option on for interlaced content."},
	{PI_XVID_GREY, "Make XviD discard chroma planes so the encoded video is greyscale only. Note that this does not speed up encoding, it just prevents chroma data from being written in the last stage of encoding."},
	{PI_XVID_QPEL, "MPEG-4 uses a half pixel precision for its motion search by default. The standard proposes a mode where encoders are allowed to use quarter pixel precision. This option usually results in a sharper image. Unfortunately it has a great impact on bitrate and sometimes the higher bitrate use will prevent it from giving a better image quality at a fixed bitrate. It's better to test with and without this option and see whether it is worth activating."},
	{PI_XVID_GMC, "Enable Global Motion Compensation, which makes XviD generate special frames (GMC-frames) which are well suited for Pan/Zoom/ Rotating images. Whether or not the use of this option will save bits is highly dependent on the source material."},
	{PI_XVID_TRELLIS, "Trellis Quantization is a kind of adaptive quantization method that saves bits by modifying quantized coefficients to make them more compressible by the entropy encoder. Its impact on quality is good, and if VHQ uses too much CPU for you, this setting can be a good alternative to save a few bits (and gain quality at fixed bitrate) at a lesser cost than with VHQ."},
	{PI_XVID_CARTOON, "Activate this if your encoded sequence is an anime/cartoon. It modifies some XviD internal thresholds so XviD takes better decisions on frame types and motion vectors for flat looking cartoons."},
	{PI_XVID_QUANTTYPE, "Sets the type of quantizer to use. For high bitrates, you will find that MPEG quantization preserves more detail. For low bitrates, the smoothing of H.263 will give you less block noise. When using custom matrices, MPEG quantization must be used."},
	{PI_XVID_CM, "The usual motion estimation algorithm uses only the luminance information to find the best motion vector. However for some video material, using the chroma planes can help find better vectors. This setting toggles the use of chroma planes for motion estimation."},
	{PI_XVID_CO, "Enable a chroma optimizer prefilter. It will do some extra magic on color information to minimize the stepped-stairs effect on edges. It will improve quality at the cost of encoding speed. It reduces PSNR by nature, as the mathematical deviation to the original picture will get bigger, but the subjective image quality will raise. Since it works with color information, you might want to turn it off when encoding in greyscale."},
	{PI_XVID_HQAC, "Activates High Quality AC coefficient prediction from neighbor blocks."},
	{PI_XVID_VHQ, "The motion search algorithm is based on a search in the usual color domain and tries to find a motion vector that minimizes the difference between the reference frame and the encoded frame. With this setting activated, XviD will also use the frequency domain (DCT) to search for a motion vector that minimizes not only the spatial difference but also the encoding length of the block. (Fastest to slowest)"},
	{PI_XVID_EXTRAOPTS, "Extra options to pass to Xvid codec"},
	{PI_MP_OPTS, "Extra options to pass to MPlayer"},
	{PI_TAGGING_NAMING, "Options of file naming and tagging"},
	{PI_RESAMPLE, "Changes the sample rate of the audio stream."},
	{PI_RESAMPLE_FREQ, "Output sample frequency in Hz"},
	{PI_RESAMPLE_HI, "Allow or disallow the output frequency to differ slightly from the frequency specified. This improves speed."},
	{PI_RESAMPLE_METHOD, "Selects which resampling method to use."},
	{PI_EQ, "10 octave band graphic equalizer, implemented using 10 IIR band pass filters. This means that it works regardless of what type of audio is being played back. The center frequencies for the 10 bands are listed below."},
	{PI_CHANNELS, "Can be used for adding, removing, routing and copying audio channels."},
	{PI_SURROUND, "Decoder for matrix encoded surround sound like Dolby Surround. Many files with 2 channel audio actually contain matrixed surround sound. Requires a sound card supporting at least 4 channels."},
	{PI_DELAY, "Delays the sound to the loudspeakers such that the sound from the different channels arrives at the listening position simultaneously. It is only useful if you have more than 2 loudspeakers."},
	{PI_XSTEREO, "(Linearly) increases the difference between left and right channels which adds some sort of 'live' effect to playback."},
	{PI_VOLNORM, "Maximizes the volume without distorting the sound."},
	{PI_LADSPA, "Load a LADSPA (Linux Audio Developers Simple Plugin API) plugin. This filter is reentrant, so multiple LADSPA plugins can be used at once."},
	{PI_COMP, "Compressor/expander filter usable for microphone input. Prevents artifacts on very loud sound and raises the volume on very low sound."},
	{PI_VOL, "Software volume control. Use this filter with caution since it can reduce the signal to noise ratio of the sound."},
	{PI_VOL_SOFTCLIP, "Soft-clipping can make the sound more smooth if very high volume levels are used. Enable this option if the dynamic range of the loudspeakers is very low."},
	{PI_VOL_GAIN, "Sets the desired gain in dB for all channels in the stream from -200dB to +60dB, where -200dB mutes the sound completely and +60dB equals a gain of 1000."},
	{PI_SURROUND_DELAY, "Delay time in ms for the rear speakers (0 to 1000). This delay should be set as follows: If d1 is the distance from the listening position to the front speakers and d2 is the distance from the listening position to the rear speakers, then the delay d should be set to 15ms if d1 <= d2 and to 15 + 5*(d1-d2) if d1 > d2."},
	{PI_XSTEREO_CO, "Sets the difference coefficient. 0.0 means mono sound (average of both channels), with 1.0 sound will be unchanged, with -1.0 left and right channels will be swapped."},
	{PI_LADSPA_FILE, "Specifies the LADSPA plugin library file. If LADSPA_PATH is set, it searches for the specified file. If it is not set, you must supply a fully specified pathname."},
	{PI_LADSPA_LABEL,"Specifies the filter within the library. Some libraries contain only one filter, but others contain many of them. Entering help here, will list all available filters within the specified library, which eliminates the use of listplugins from the LADSPA SDK."},
	{PI_LADSPA_CTRL, "Controls are zero or more floating point values that determine the behaviour of the loaded plugin (for example delay, threshold or gain). In verbose mode (add ??v to the MPlayer command line), all available controls and their valid ranges are printed. This eliminates the use of analyseplugin from the LADSPA SDK."},
	{PI_264_QP, "This selects the quantizer to use for P-frames. 20-40 is a useful range. Lower values result in better fidelity, but higher bitrates. 0 is lossless. Note that quantization in H.264 works differently from MPEG-1/2/4: H.264's quantization parameter (QP) is on a logarithmic scale. The mapping is ap- proximately H264QP = 12 + 6*log2(MPEGQP). For example, MPEG at QP=2 is equivalent to H.264 at QP=18."},
	{PI_264_TURBO, "Fast first pass mode. During the first pass of a two or more pass encode it is possible to gain speed by disabling some options with negligible or even no impact on the final pass output quality. Level 1 can increase first pass speed up to 2x with no change in the global PSNR of the final pass com- pared to a full quality first pass. Level 2 can increase first pass speed up to 4x with about +/- 0.05dB change in the global PSNR of the final pass compared to a full quality first pass."},
	{PI_264_SUBQ, "Adjust subpel refinement quality. This parameter controls quality versus speed tradeoffs involved in the motion estimation decision process. subq=5 can compress up to 10% better than subq=1. From fastest to slowest."},
	{PI_264_KEYINT, "Sets maximum interval between IDR-frames. Larger values save bits, thus improve quali- ty, at the cost of seeking precision. Unlike MPEG-1/2/4, H.264 does not suffer from DCT drift with large values of keyint."},
	{PI_264_KEYINTMIN, "Sets minimum interval between IDR-frames. If scenecuts appear within this interval, they are still encoded as I-frames, but do not start a new GOP. In H.264, I-frames do not neces- sarily bound a closed GOP because it is allowable for a P-frame to be predicted from more frames than just the one frame before it (also see frameref). Therefore, I-frames are not necessarily seekable. IDR-frames restrict subsequent P-frames from refer- ring to any frame prior to the IDR-frame."},
	{PI_264_FRAMEREF, "Number of previous frames used as predictors in B- and P-frames. This is effective in anime, but in live-action material the improvements usually drop off very rapidly above 6 or so reference frames. This has no effect on decoding speed, but does increase the memory needed for decoding. Some decoders can only handle a maximum of 15 reference frames."},
	{PI_264_QPSTEP, "Maximum value by which the quantizer may be incremented/decremented between frames"},
	{PI_264_QCOMP, "Quantizer compression. A lower value makes the bitrate more constant, while a higher value makes the quantization parameter more constant."},
	{PI_DEINTERLACE, "Experimental 'stateless' inverse telecine filter."},
	{PI_CROP, "Crops the given part of the image and discards the rest. Useful to remove black bands from widescreen movies."},
	{PI_CROPDETECT, "Calculates necessary cropping parameters."},
	{"videofilter.scale.enabled", "Scales the image with the software scaler (slow) and performs a YUV<->RGB colorspace conversion"},
	{PI_PP, "Enables the specified chain of postprocessing sub-filters. "},
	{PI_DEN, "This filter aims to reduce image noise producing smooth images and making still images really still (This should enhance compressibility)."},
	{PI_PAGE_VCODEC, "Settings of video codecs"},
	{PI_LAME, "LAME is an LGPL MP3 encoder. The Open source development model allowed to improve its quality and speed since 1999. It is now an highly evolved MP3 encoder, with quality and speed able to rival state of the art commercial encoders."},
	{PI_OGG, "Ogg Vorbis is a completely open, patent-free, professional audio encoding and streaming technology with all the benefits of Open Source."},
	{PI_AACP, "Coding Technology's AAC+V2 encoder featuring Parametric Stereo"},
	{PI_HLX, "Helix DNA Producer"},
	{PI_FAAC, "The Free AAC Encoder"},
	{PI_FLAC, "Free Lossless Audio Codec"},
	{PI_WV, "WavPack is a completely open audio compression format providing lossless, high-quality lossy, and a unique hybrid compression mode."},
	{PI_APE, "Monkey's Audio is a fast and easy way to compress digital music."},
	{PI_CLI, "This allows you to use any generic CLI encoder that reads PCM data from stdin."},
	{PI_FF_AUDIO, "Use the audio encoders provided by FFMPEG."},
	{PI_264, "x264 is a free library for encoding H264/AVC video streams."},
	{PI_XVID, "Xvid is an open source MPEG4 based video codec"},
	{PI_FF_VIDEO, "FFmpeg is a complete solution to record, convert and stream audio and video. It includes libavcodec, the leading audio/video codec library."},
	{PI_GENERAL, "Options that control the generic behaviors of MediaCoder"},
	{PI_TASK, "Options related with batch tasking"},
	{PI_AUDIO_OPTS, "Generic audio encoding related options"},
	{PI_VIDEO_OPTS, "Generic video encoding related options"},
	{PI_CONTAINER_OPTS, "Container related options"},
	{PI_DECODE, "Generic audio/video decoding related options"},
	{PI_MP, "MPlayer can decode many formats of audio files. What makes it different is that it can decode audio stream within video files."},
	{PI_WA, "As long as a Winamp plugin for a certain audio format is available, this format can be decoded."},
	{PI_WAVE, "Reading PCM data directly from a waveform file."},
	{"overall.tag.fileNameFormat", "Variable expression: $(variable name)\r\nAvailable variables: Artist, Title, Album, Track, Genre, Year, Comment, NowYear, NowMonth, NowDay, NowWeekDay, NowHour, NowMin, NowSec, SampleRate, SampleRateKhz, SampleBits, ChannelNum, DestFile, DestDir, SourceFile, SourceFileName, TempFile, SourceFile, AudioFiles."},
	{"overall.decoding.startTime", "The time (seconds) to starting transcoding from."},
	{"overall.decoding.duration", "The amount of time (seconds) to transcode."},
	{"overall.task.overwrite", "The action to take when the target file already exists"},
	{PI_KEEP_UNFINISH, "Enable this to keep partially transcoded files"},
	{"overall.task.keepTemp", "Enable this to keep all intermediate files created in the temporary directory."},
	{PI_DEL_ORIGINAL, "Enable this to automatically delete the original file after it is transcoded. Use with caution!"},
	{"overall.task.shutdown", "Enable this to power down your PC after all tasks are done."},
	{"overall.tagging.tag", "Enable this to add tags for the target files"},
	{"overall.tag.formatting", "Enable this to use formatted string as file name"},
	{"overall.tag.dupDir", "Enable this keep the directory structure of the source files"},
	{PI_XVID_THREADS, "Split each frame into slices and encode them in parallel. This has a slight penalty to compression."},
	{PI_FF_QNS, "Mode 1: Only lower the absolute value of coefficients. Mode 2:	Only change coefficients before the last non-zero coefficient + 1. Mode 3: Try all."},
*/
	{0,0}
};
