#ifndef PARAMLISTDEF_H
#define PARAMLISTDEF_H

#define PT_DEFAULT 0
#define PT_INT 1
#define PT_STRING 2
#define PT_ENUM 3
#define PT_BOOL 4
#define PT_FLOAT 5
#define PT_FILE 6
#define PT_DIR 7
#define PT_NODE 8
#define PT_CATALOG 9
#define PT_ROOT 10
#define PT_EXTEND -1

#define PF_NOSAVE 0x1
#define PF_NOREVERT 0x2

typedef struct _PARAM_DATA {
	unsigned char type;
	unsigned char flags;
	short min;
	int max;
	char* text;
	char* key;
	char* enums;
	char* desc;
	void* valueDefault;
	void* value;
	struct _PARAM_DATA* sub;
} PARAM_DATA;

typedef struct {
	char* text;
	char* enums;
} PARAM_ENTRY;

typedef struct {
	int id;
	char* desc;
} PARAM_DESC;

typedef int (*PARAM_NOTIFY)(int, void*);

#endif