#include <windows.h>
#include <stdio.h>
#include "resource.h"
#include "..\..\include\devplugin.h"

#define DEVICE_NAME "Nokia N70"

int notify(int event, void* arg);

static DEV_PLUGIN_HEADER plugin= {
	DEVICE_NAME,
	DEV_TYPE_PHONE,
	notify,
	0,
	{41, 109, 176, 208},
};

extern "C" __declspec(dllexport) DEV_PLUGIN_HEADER* GetPluginHeader()
{
	return &plugin;
}

static int CALLBACK DlgProc(HWND hwnd,UINT msg,WPARAM wParam,LPARAM lParam)
{
	return 0;
}

static int notify(int event, void* arg)
{
	switch (event) {
	case DEV_EVENT_LOAD:
		plugin.hWnd = CreateDialog(plugin.hInst, MAKEINTRESOURCE(IDD_PANEL), plugin.hParent, DlgProc);
		plugin.hScreen = GetDlgItem(plugin.hWnd, IDC_SKIN);
		return plugin.hWnd ? 0 : -1;
	case DEV_EVENT_UNLOAD:
		DestroyWindow(plugin.hWnd);
		plugin.hWnd = 0;
		break;
	}
	return 0;
}

BOOL APIENTRY DllMain( HINSTANCE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved
					 )
{
	switch (ul_reason_for_call) {
	case DLL_PROCESS_ATTACH: {
		HRSRC rs = FindResource(hModule, MAKEINTRESOURCE(IDR_XML1), "XML");
		HGLOBAL rsdata = LoadResource(hModule, rs);
		plugin.xml = (char*)LockResource(rsdata);
		plugin.hInst = hModule;
		plugin.hLogo = LoadBitmap(hModule,  MAKEINTRESOURCE(IDB_LOGO));
		} break;
	case DLL_PROCESS_DETACH:
		DeleteObject(plugin.hLogo);
		break;
	}
    return TRUE;
}