typedef struct {
	char* name;
	char* value;
	char* subvalue;
} TRACK_TOKEN;

typedef struct {
	TRACK_TOKEN* tokens;
	int valuecount;
	unsigned int begin;
	unsigned int end;
} CUE_TRACK_INFO;

class CCueSheet
{
public:
	int LoadCueSheet(char* filename);
	int ParseCueSheet();
	TRACK_TOKEN* GetTrackInfo(int trackno, char* name);
	int FillCueSheetItem(int trackno, T_ITEM* item);
	void Purge();
	CCueSheet():trackcount(0),data(0) {}
	~CCueSheet() { Purge(); }
	int trackcount;
	char file[MAX_PATH];
	CUE_TRACK_INFO* tracks;
	char* data;
private:
};

typedef struct {
	CString title;
	CString artist;
} TRACK_INFO;

class CDiscInfo {
public:
	CDiscInfo():trackcount(0) {}
	~CDiscInfo() { delete [] track; }
	void SetTrackCount(int count);
	TRACK_INFO* track;
	CString title;
	CString artist;
	CString genre;
	int year;
	int trackcount;
};

class CAddTrackDialog:public CWindow {
public:
	CCueSheet cue;
	CDiscInfo disc;
private:
	bool onClick(int dlgid);
	bool onSelChange(int dlgid);
	bool onCreate();
	bool onDestroy();
	void Add();
	void RefreshDiscInfo();
	void RefreshTrackInfo();
	int GetDiscRoot(char* buf, int bufsize);
	int tracktype;
	int trackcount;
};

class CCddb:public CWindow{
public:
	CString result;
	int QueryDisc(int cdrom);
	int QueryTrackNames();
	int GetQueryOptions(int opt, CString& str);
};
