/*******************************************************************
* MediaCoder - The universal audio/video transcoder
* Copyright (c) 2005-06 Stanley Huang <reachme@citiz.net>
* All rights reserved.
*******************************************************************/

#ifndef VIDEO_OPTIONS_H
#define VIDEO_OPTIONS_H

typedef enum {
	OD_SUMMARY,
	OD_OUTPUT,
	OD_AUDIO,
	OD_VIDEO,
	OD_CONTAINER,
	OD_PICTURE,
	OD_TIME,
	OD_TAGGING,
	OD_PREVIEW,
	OD_COUNT,
} OPT_DIALOGS;

class CDlgVideoOption:public COptionDialog
{
public:
	CDlgVideoOption();
	int Open(CWindow* parent);
	char* GetName() {return "Video";}
	void Refresh();
private:
	bool onCommand2(int dlgid, int code);
};

class CDlgContainer:public COptionDialog
{
public:
	CDlgContainer();
	int WrapFiles(char* destfile);
	char* GetName() {return "Container";}
private:
	bool onClick(int dlgid);
};

class CDlgAudio:public COptionDialog
{
public:
	CDlgAudio();
	char* GetName() {return "Audio";}
	void Refresh();
private:
	bool onCreate2();
	bool onClick(int dlgid);
	bool onSelChange(int dlgid);
	bool onCommand2(int dlgid, int code);
};

class CDlgSummary:public COptionDialog
{
public:
	CDlgSummary() { dialogid = IDD_SUMMARY; }
	char* GetName() {return "Summary";}
	void Refresh();
private:
};

class CDlgPicture:public COptionDialog
{
public:
	CDlgPicture();
	char* GetName() {return "Picture";}
	void Refresh();
private:
	bool onCreate2();
	bool onCommand2(int dlgid, int code);
	bool onSelChange(int dlgid);
	bool onClick(int dlgid);
	bool SaveChange(int dlgid, char* value);
};

class CDlgTagging:public COptionDialog
{
public:
	CDlgTagging();
	char* GetName() {return "Texts";}
	void Refresh();
private:
	bool onCreate2();
	bool onCommand2(int dlgid, int code);
	bool onSelChange(int dlgid);
	bool onClick(int dlgid);
};

class CDlgTime:public COptionDialog
{
public:
	CDlgTime();
	char* GetName() {return "Time";}
	void Refresh();
private:
	bool onCommand2(int dlgid, int code);
	bool onClick(int dlgid);
	void FormatTime(char* str, int timeval);
	void RefreshTime(int idx);
};

class CDlgPreview:public COptionDialog
{
public:
	CDlgPreview() { dialogid = IDD_PREVIEW; }
	char* GetName() {return "Preview";}
private:
	bool onCreate2();
	bool onClick(int dlgid);
	bool onScroll(int dlgid, int code);
	bool onTimer(int id);
	void SetControlMode(int mode);
	int sliderMax;
	int step;
	CVideoWindow video;
};

class CDlgOutput:public COptionDialog
{
public:
	CDlgOutput();
	char* GetName() {return "Output";}
private:
	bool onClick(int dlgid);
};

#define NAV_BUTTON_WIDTH 78
#define NAV_BUTTON_HEIGHT 78

class CDlgDevNav:public CWindow
{
private:
	bool onCreate();
	bool onClose();
	bool onSize(int width, int height);
	bool onClick(int dlgid);
};

class CDlgPopup:public CWindow
{
public:
	CDlgPopup():dlg(0) {}
	~CDlgPopup();
	void SetDlg(COptionDialog* newdlg);
	void Open(CWindow* parent = 0);
	void Refresh();
private:
	bool onClose();
	COptionDialog* dlg;
};

#endif
